unit uEasyScan;

 //verso 1.0.0.0 = 26/01/2015

interface

uses
 hyieutils;

type
 TMPixel = Record
  Blue:  Byte;
  Green: Byte;
  Red:   Byte;
 end;

 PMPixelArray = ^TMPixelArray;
 TMPixelArray = array[0..32767] of TMPixel;

 //Master Studio Criado por Wesley Bobato...
 procedure Filter1(const bmp: TIEBitmap; const chRed, chGreen, chBlue: Boolean);
 procedure InvertColor(const bmp: TIEBitmap);
 procedure GrayColor(const bmp: TIEBitmap);
 procedure Solarize(const bmp: TIEBitmap);

implementation

//============================================================================//
procedure Filter1(const bmp: TIEBitmap; const chRed, chGreen, chBlue: Boolean);
var
 p:          PMPixelArray;
 x, y, Gray: Integer;
begin
 for y := 0 to Pred(bmp.Height) do
  begin
   p := bmp.ScanLine[y];
   for x := 0 to Pred(bmp.Width) do
    with p^[x] do
     begin
      Gray  := (Red + Green + Blue) div 3; //(Red * 3 + Blue * 4 + Green * 2) div 9;

      if chBlue then
       Blue := Gray;

      if chRed then
       Red := Gray;

      if chGreen then
       Green := Gray;
     end;
  end;
end;

//============================================================================//
procedure InvertColor(const bmp: TIEBitmap);
var
 p:    PMPixelArray;
 x, y: Integer;
begin
 for y := 0 to Pred(bmp.Height) do
  begin
   p := bmp.ScanLine[y];
   for x := 0 to Pred(bmp.Width) do
    with p^[x] do
     begin
      Blue  := 255 - Blue;
      Green := 255 - Green;
      Red   := 255 - Red;
     end;
  end;
end;

//============================================================================//
procedure Solarize(const bmp: TIEBitmap);
var
 p:    PMPixelArray;
 x, y: Integer;
begin
 for y := 0 to Pred(bmp.Height) do
  begin
   p := bmp.ScanLine[y];
   for x := 0 to Pred(bmp.Width) do
    with p^[x] do
     begin
      if Blue  > 127 then Blue  := 255 - Blue;
      if Green > 127 then Green := 255 - Green;
      if Red   > 127 then Red   := 255 - Red;
     end;
  end;
end;


//============================================================================//
procedure GrayColor(const bmp: TIEBitmap);
var
 p:          PMPixelArray;
 x, y, Gray: Integer;
begin
 for y := 0 to Pred(bmp.Height) do
  begin
   p := bmp.ScanLine[y];
   for x := 0 to Pred(bmp.Width) do
    with p^[x] do
     begin
      Gray  := (Red + Green + Blue) div 3; //(Red * 3 + Blue * 4 + Green * 2) div 9;
      Blue  := Gray;
      Red   := Gray;
      Green := Gray;
     end;
  end;
end;

end.
